package world;

import java.awt.Graphics;
import java.awt.Color;
import java.awt.Point;

import java.util.*;

//
//	use only getPosition, getOrientation, forward, backward, spin_left, spin_right, and stop
//
//  do not directly change position and orientation
//
public class Robot extends Entity
{
	public Robot(Vector2D _position, Vector2D _orientation){
		position = _position;
		orientation = _orientation;
		r=20;
		weight = 15;
	}
	
	
	
	
	public void paint(Graphics g){

		g.setColor(Color.white);
		g.fillOval((int)position.x - r, (int)position.y -r, r*2, r*2);
		
		g.setColor(Color.black);
		g.drawOval((int)position.x - r, (int)position.y -r, r*2, r*2);
		g.drawString("robot", (int)position.x+r+5, (int)position.y+5);
		
		int x = (int) (r * orientation.x);
		int y = (int) (r * orientation.y);
		g.drawLine((int)position.x+x/2, (int)position.y+y/2, (int)position.x+x, (int)position.y+y);
		

		
	}
	public boolean contains(java.awt.Point p){
		return ( Vector2D.distance(position, p) < r);
	}


	
	
	

	public Vector2D get_orientation(){
		return orientation;
	}
	

	
	
	

	int current_motion = 0;
	static final int STOP = 0;
	static final int FORWARD = 1;
	static final int SPIN_LEFT = 2;
	static final int SPIN_RIGHT = 3;
	
	
	public void forward(){
		current_motion = FORWARD;
	}
	public void stop(){
		current_motion = STOP;
	}
	public void spin_left(){
		current_motion = SPIN_LEFT;
	}
	public void spin_right(){
		current_motion = SPIN_RIGHT;
	}
	
	
}
